{{progress=100}}
{{title='Evaluation'}}
{{icon="results"}}
{{chosenUseCase = db(db.t_applicationselection).select().first().as_dict()["f_name"]}}
<head>
    <script src="{{=URL('static','js/chartScript.js')}}"></script>
</head>
{{extend 'evaluationLayout.html'}}
<body>
    
     <script>
        //Javascript for the Economic Graph
        
    </script>
    <div class="controls">
            <h5 class="label">Choose the Goal:</h5>
            <select name="chartData" id="chartData" onchange="switchChart()">
              <option value="change">Change</option>
              <option value="stacked">Stacked</option>
              {{for key in mainkpi_dict_labels:}}<option value="{{=XML(key)}}">{{=XML(mainkpi_dict_labels[key])}}</option>{{pass}}
            </select>
        </div>
    <div id="barGraphDiv">
        <canvas id="graph"></canvas>
    </div>
    <script>
        //Javascript for the KPI Graphs
        {{from gluon.serializers import json}}
        function createDataset(label, color, dataset){
            return {label: label,backgroundColor: color,data: dataset}
        }
        //Prepare the data for the Graph
        //The MainKPI Data
        var datas = {{=XML(dataset_main[0])}};
        const labels = {{=XML(dataset_main[1])}};
        var datas_5g = {{=XML(dataset_main[2])}};
        
        const data = {
            labels: labels,
            datasets: [{
            label: 'Without 5G',
            backgroundColor: 'rgb(64, 122, 170)',
            data: datas,
            },{
            label: 'With 5G',
            backgroundColor: 'rgb(0, 68, 121)',
            data: datas_5g,
            }]
        };
        //The Change Data
        var datas_change = [];
        var change_data = {{=XML(change_data)}}; 
        for (array in change_data){
            datas_change.push(change_data[array][0]);
        };
        const labels_change = {{=XML(dataset_main[1])}};
        
        const data_change = {
            labels: labels_change,
            datasets: [{
            label: 'With 5G-Total',
            backgroundColor: 'rgb(0, 68, 121)',
            data: datas_change,
            }]
        };
         //The Stacked Data
        var datas_change_5g = [];
        for (array in change_data){
            datas_change_5g.push(change_data[array][0]);
        };
        var datas_change_5g_lat = [];
        for (array in change_data){
            datas_change_5g_lat.push(change_data[array][1]);
        };
        var datas_change_5g_avail = [];
        for (array in change_data){
            datas_change_5g_avail.push(change_data[array][2]);
        };
        var datas_change_5g_reli = [];
        for (array in change_data){
            datas_change_5g_reli.push(change_data[array][3]);
        };
        var datas_change_5g_ict = [];
        for (array in change_data){
            datas_change_5g_ict.push(change_data[array][4]);
        };
        const data_changed_stack = {
            labels: labels_change,
            datasets: [{
            label: 'With 5G - Total',
            backgroundColor: 'rgb(0, 68, 121)',
            data: datas_change_5g,
            stack: 'Stack 1'
            },
            {{if chosenUseCase != "blisk":}}
                {
                label: 'With 5G - Availability',
                backgroundColor: 'rgba(121, 121, 121)',
                data: datas_change_5g_avail,
                },
            {
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: datas_change_5g_lat,
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: datas_change_5g_reli,
            },
                       {{pass}}
           {
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: datas_change_5g_ict,
            }]
        };
        {{if not (db(db.t_goals).select().first().as_dict()['f_flex'] == False):}}
        //The FlexKPI Data
        const data_flex = {
            labels: {{=XML(dataset_flex[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgb(0, 68, 121)',
            data: repackArray({{=XML(dataset_flex[1])}})
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_flex[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_flex[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_flex[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_flex[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_mob'] == False):}}
        //The MobilityKPI Data
        const data_mob = {
            labels: {{=XML(dataset_mob[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_mob[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_mob[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_mob[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_mob[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_mob[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_prod'] == False):}}
        //The ProductivityKPI Data
        const labels_prod = {{=XML(dataset_prod[0])}};
        const data_prod = {
            labels: labels_prod,
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_prod[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_prod[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_prod[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_prod[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_prod[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_qual'] == False):}}
        //The QualityKPI Data
        const data_qual = {
            labels: {{=XML(dataset_qual[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_qual[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_qual[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_qual[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_qual[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_qual[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_safe'] == False):}}
        //The SafetyKPI Data
        var datas_safe = {{=XML(dataset_safe[0])}};
        const labels_safe = {{=XML(dataset_safe[1])}};
        var datas_5g_safe = {{=XML(dataset_safe[2])}};
        
        const data_safe = {
            labels: {{=XML(dataset_safe[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_safe[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_safe[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_safe[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_safe[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_safe[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_sus'] == False):}}
        //The SustainabilityKPI Data
        var datas_sus = {{=XML(dataset_sus[0])}};
        const labels_sus = {{=XML(dataset_sus[1])}};
        var datas_5g_sus = {{=XML(dataset_sus[2])}};
        
        const data_sus = {
            labels: {{=XML(dataset_sus[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_sus[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_sus[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_sus[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_sus[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_sus[5])}}),
            }]
        };
        {{pass}}
        {{if not (db(db.t_goals).select().first().as_dict()['f_util'] == False):}}
        //The UtilizationKPI Data
        const data_util = {
            labels: {{=XML(dataset_util[0])}},
            datasets: [{
            label: 'With 5G',
            backgroundColor: 'rgba(0, 68, 121)',
            data: repackArray({{=XML(dataset_util[1])}}),
            },{{if chosenUseCase != "blisk":}}{
            label: 'With 5G - Availability',
            backgroundColor: 'rgba(121, 121, 121)',
            data: repackArray({{=XML(dataset_util[3])}}),
            },{
            label: 'With 5G - Latency',
            backgroundColor: 'rgba(0, 168, 170)',
            data: repackArray({{=XML(dataset_util[2])}}),
            },{
            label: 'With 5G - Reliability',
            backgroundColor: 'rgba(64, 122, 170)',
            data: repackArray({{=XML(dataset_util[4])}}),
            },{{pass}}{
            label: 'With 5G - ICT',
            backgroundColor: 'rgba(174, 204, 230)',
            data: repackArray({{=XML(dataset_util[5])}}),
            }]
        };
        {{pass}}
        //Save the canvas in a variable
        const ctx = document.getElementById('graph');
        
        var config = {
            type: 'bar',
            data: data_change,
            options: {
                maintainAspectRatio: false,
                plugins:{
                    legend: {
                        onHover: function(e) {
                            e.native.target.style.cursor = 'pointer';
                        }
                    }
                },
                responsive: true,
                scales:{
                    yAxis:{
                        title:{
                            display: true,
                            text: "",
                        },
                        ticks:{
                            callback: function(value, index, values) {
                                return value +' %';
                            }
                        }
                    },
                    xAxis:{
                        stacked: false
                    }
                }
            },
        };

        var myChart = new Chart(
            ctx,
            config
        );
        //Function that allows us to change the data for the Graph (switch between Overall and Specific view)
        function switchChart(){
            myChart.destroy();
            var datatype = document.getElementById('chartData').value;
            switch (datatype){
                case "change":
                    config.data = data_change;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "stacked":
                    config.data = data_changed_stack;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "flexibility":
                    config.data = data_flex;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "mobility":
                    config.data = data_mob;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "productivity":
                    config.data = data_prod;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "quality":
                    config.data = data_qual;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "safety":
                    config.data = data_safe;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "sustainability":
                    config.data = data_sus;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
                case "utilization":
                    config.data = data_util;
                    config.options.scales.yAxis.stacked = false;
                    config.options.scales.xAxis.stacked = false;
                    myChart = new Chart(ctx, config);
                    break;
            };
        };
        
        function repackArray(array){
            var data = [];
            for (x of Array(array.length).keys()){
                data[x] = array[x][0];
            }
            return data;
        }
    </script>
    
        <script>
            //Set RoI in Field to roi_delta value
            //Get Box Names
            

            /*
            var inputImplementationCost = document.getElementById("5gimplementationcost");
            var inputImplementationCostLabel = document.querySelector('[for="5gimplementationcost"]');
            var inputTechInvestment = document.getElementById("techinvestment");
            var inputTechInvestmentLabel = document.querySelector("[for='techinvestment']");
            */
            //Set the inputs to visible or invisible based on if they were checked under selectApplication
            
            
            //Function to change the Invest and call subsequent changes like adapting the economic graph
        </script>
    <!--</div>-->
    <div id="buttonDiv">
            <div id="backToMain"><a href="{{=backUrl}}" class="button">Back</a></div>
            <div id = "nextButton">
                <a class="button" href='{{=nextUrl}}'>
                  Continue
                </a>
        </div>
    </div>
</body>
